function love.load()
    -- pic must be monochrome black and white for this example code to work!
    pic    = love.graphics.newImage("pic.png")
    color1 = {255, 0, 0}
    color2 = {0, 0, 255}
    newpic = change_monochrome_color(pic, color1, color2)
end

function love.draw()   
    love.graphics.draw(pic, 0, 33)
    love.graphics.draw(newpic, 400, 300)
    
    love.graphics.print("The current colors are:", 433, 33)
    love.graphics.print("color1: {" .. color1[1] .. ", " .. color1[2] .. ", " .. color1[3] .. "}", 433, 33+1*14)
    love.graphics.print("color2: {" .. color2[1] .. ", " .. color2[2] .. ", " .. color2[3] .. "}", 433, 33+2*14)
    love.graphics.print("Press the spacebar to change colors randomly.", 433, 33+4*14)
end

function change_monochrome_color(image, color1, color2)
    result       = love.graphics.newCanvas(image:getWidth(), image:getHeight())
    inverse      = love.graphics.newCanvas(image:getWidth(), image:getHeight())
    blank_color2 = love.graphics.newCanvas(image:getWidth(), image:getHeight())
    
    -- replace all white pixels with color1
    love.graphics.setCanvas(result)
    love.graphics.clear(color1)
    love.graphics.setBlendMode("multiply")
    love.graphics.draw(image, 0, 0)
    love.graphics.setBlendMode("alpha")
    love.graphics.setCanvas()
    
    -- calculate the inverse of the image
    love.graphics.setCanvas(inverse)
    love.graphics.clear(255, 255, 255)
    love.graphics.setBlendMode("subtract")
    love.graphics.draw(image, 0, 0)
    love.graphics.setBlendMode("alpha")
    love.graphics.setCanvas()
    
    -- replace all black pixels with color2 in inverse
    love.graphics.setCanvas(blank_color2)
    love.graphics.clear(color2)
    love.graphics.setBlendMode("multiply")
    love.graphics.draw(inverse, 0, 0)
    love.graphics.setBlendMode("alpha")
    love.graphics.setCanvas()
    
    -- add the result up
    love.graphics.setCanvas(result)
    love.graphics.setBlendMode("add")
    love.graphics.draw(blank_color2, 0, 0)
    love.graphics.setBlendMode("alpha")
    love.graphics.setCanvas()
    
    
    return result
end

function love.keypressed(key)
    if key == "escape" then
        love.event.quit()
    end
    
    if key == "space" then
        color1 = {love.math.random(0, 255), love.math.random(0, 255), love.math.random(0, 255)}
        color2 = {love.math.random(0, 255), love.math.random(0, 255), love.math.random(0, 255)}
        newpic = change_monochrome_color(pic, color1, color2)
    end
end
